import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.Timer;
import java.util.*;


public class Minesweeper extends JFrame {
 
   int Minenzahl = 15;
  
  
  public class MineButton extends JLabel {
    MineButton links, rechts,oben, unten;
    int Wert = 0;
    boolean aufgedeckt = false;
   
    
    MineButton () {
      this.setVerticalAlignment(JLabel.CENTER);
      this.setHorizontalAlignment(JLabel.CENTER); 
    
      
      this.addMouseListener(new MouseAdapter() { 
        public void mousePressed(MouseEvent evt) { 
          if (evt.isMetaDown() == true) { //rechte Maustaste- bei false linke Maustaste
             RechtsClick();  
          } else { 
             LinksClick();      
             } 
          }     
      });  
    }        
    
    void LinksClick() {
      if (this.Wert > 0) {
        this.setBackground(Color.WHITE);
        this.setText(Integer.toString(this.Wert));
      } else {
        if (this.Wert == -1) {
          this.setText("X");
          this.setBackground(Color.RED);
        } else {
          if (this.Wert == 0) {
            this.Aufdecken();
          } // end of if
        } // end of if-else
        
      } // end of if-else
      }  
    
    void RechtsClick() {
         if (this.getBackground() == Color.GRAY) {
                this.setBackground(Color.YELLOW); 
                } else { 
                this.setBackground(Color.GRAY);
                } // end of if-else 
      }  
      
    
    
    void NachbarnReferenzieren (MineButton o, MineButton r, MineButton u, MineButton l) {
    this.oben = o;
      this.rechts = r; 
      this.unten = u;
      this.links = l;   
      
    }
    
    
    void WertBerechnen () {
        if (this.Wert != -1) {
             if ((this.oben != null) && (this.oben.Wert == -1)) {
                   this.Wert = this.Wert +1; 
                   }
              if ((this.rechts != null) && (this.rechts.Wert == -1)) {
                   this.Wert = this.Wert +1; 
                   }
              if ((this.unten != null) && (this.unten.Wert == -1)) {
                   this.Wert = this.Wert +1; 
                   }
              if ((this.links != null) && (this.links.Wert == -1)) {
                   this.Wert = this.Wert +1; 
                   }
                   
              if ((this.oben != null) && (this.oben.links != null) && (this.oben.links.Wert == -1)) {
                   this.Wert = this.Wert +1; 
                   }
              if ((this.oben != null) && (this.oben.rechts != null) && (this.oben.rechts.Wert == -1)) {
                   this.Wert = this.Wert +1; 
                   }
              if ((this.unten != null) && (this.unten.links != null) && (this.unten.links.Wert == -1)) {
                   this.Wert = this.Wert +1; 
                   }
              if ((this.unten != null) && (this.unten.rechts != null) && (this.unten.rechts.Wert == -1)) {
                   this.Wert = this.Wert +1; 
                   }
        }   
     }

   
    
    
    
    
    void Aufdecken() {
       /* if (this.Wert == 0){
        
           this.setBackground(Color.WHITE);
           this.aufgedeckt = true;
           
           if (this.oben != null) {
               if ((this.oben.Wert == 0) && (this.oben.aufgedeckt == false)) {
                   this.oben.Aufdecken();    
                   }
               }
               
               
           if (this.rechts != null) {
               if ((this.rechts.Wert == 0) && (this.rechts.aufgedeckt == false)) {
                   this.rechts.Aufdecken();    
                   }
               }
               
           if (this.unten != null) {
               if ((this.unten.Wert == 0) && (this.unten.aufgedeckt == false)) {
                   this.unten.Aufdecken();    
                   }
               }    
               
           if (this.links != null) {
               if ((this.links.Wert == 0) && (this.links.aufgedeckt == false)) {
                   this.links.Aufdecken();    
                   }
               } 
        }  */
    }
    
   
    
    void setGroessePosition(int x, int y) {
      this.setSize(30,30);
      this.setLocation(x,y);
      this.setOpaque(true);
      this.setBackground(Color.GRAY);
      this.setCursor(new Cursor(Cursor.HAND_CURSOR));
      this.setVisible(true);   
    }    
    
  }  
  
  public Minesweeper(String title) { 
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 616; 
    int frameHeight = 558;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    
    // Ende Komponenten
    
    setVisible(true);
    cp.setBackground(Color.LIGHT_GRAY);
    
    
    
    MineButton[][] a = new MineButton[17][17];
    
    for (int Zeile=0; Zeile<17;Zeile++) {
      for (int Spalte=0; Spalte<17 ;Spalte++ ) {
        a[Zeile][Spalte] = null;
      }     
    }     
    
    for (int Zeile=1; Zeile<16;Zeile++) {
      for (int Spalte=1; Spalte<16 ;Spalte++ ) {
        a[Zeile][Spalte] = new MineButton();
        //a[Zeile][Spalte].setVerticalAlignment(JLabel.CENTER);
        //a[Zeile][Spalte].setHorizontalAlignment(JLabel.CENTER);
      } // end of for
    } // end of for
    
    for (int Zeile=1; Zeile<16;Zeile++) {
      for (int Spalte=1; Spalte<16 ;Spalte++ ) {
        cp.add(a[Zeile][Spalte]);
        a[Zeile][Spalte].setGroessePosition (20 + (Zeile-1)*31, 20 + (Spalte-1)*31); 
      }
    }
    
    frameWidth = 20*2 + 15*31; 
    frameHeight = 20*3 + 15*31;
    setSize(frameWidth, frameHeight);
    
   
    
    for (int Zeile=1; Zeile<16;Zeile++) {
      for (int Spalte=1; Spalte<16 ;Spalte++ ) {
        // oben, rechts, unten, links 
        a[Zeile][Spalte].NachbarnReferenzieren(a[Zeile-1][Spalte] , a[Zeile][Spalte+1], a[Zeile+1][Spalte], a[Zeile][Spalte-1]);
      } // end of for 
    } // end of for
    
    
    
    for (int Zeile=1; Zeile<16;Zeile++) {
      for (int Spalte=1; Spalte<16 ;Spalte++ ) {
        // oben, rechts, unten, links 
        a[Zeile][Spalte].NachbarnReferenzieren(a[Zeile-1][Spalte] , a[Zeile][Spalte+1], a[Zeile+1][Spalte], a[Zeile][Spalte-1]);
      } // end of for 
    } // end of for
    
    // Minen legen
     // Minen knnen zufllig auch doppelt belegt sein (macht hier aber nichts)
      Random r = new Random(); 
      for (int i=1; i<Minenzahl+1; i++) {
           int Randx = r.nextInt(15)+1;
           int Randy = r.nextInt(15)+1;
           a[Randx][Randy].Wert = -1; // Minen -1
           }

    for (int Zeile=1; Zeile<16; Zeile++) {
      for (int Spalte=1; Spalte<16 ; Spalte++ ) {
            a[Zeile][Spalte].WertBerechnen();
      }
    }
         
    
    // Zur berprfung der richtigen Programmierung
    // Ansonsten diese Zeilen auskommentieren !!!
     for (int Zeile=1; Zeile<16; Zeile++) {
      for (int Spalte=1; Spalte<16 ; Spalte++ ) {
            a[Zeile][Spalte].setText(Integer.toString(a[Zeile][Spalte].Wert));
      }
    }  
  } // end of public Minesweeper
  
  // Anfang Methoden
  // Ende Methoden
  
  public static void main(String[] args) {
    new Minesweeper("Minesweeper");
  } // end of main
  
} // end of class Minesweeper
  