unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;
// STDControls wegen TLabel ergänzen

  type

  { TMinenButton }

  { TMineButton }

  TMineButton = class(TLabel)
     public
      wert: integer;
      markiert: boolean;
      links, oben, rechts, unten : TMineButton;
      constructor create(AOwner: TComponent);  override;
      procedure NachbarnReferenzieren (u, l, o, r: TMineButton);
      procedure setGroessePosition(x, y: integer);
      procedure WertBerechnen;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;


type

  { TForm1 }

  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure aufdecken(i, j: integer);
    procedure Timer1Timer(Sender: TObject);
    public

    //button: array[0..14,0..14] of TMinenButton;
  end;

  {
  TLampe = class (TShape)
      links, oben, rechts, unten : TLampe;
      procedure NachbarnReferenzieren (u, l, o, r: TLampe);
      procedure LichtAnAus;
      procedure setGroessePosition(x,y: integer);
      procedure MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;






procedure TLampe.LichtAnAus;
begin
  if (self.Brush.color = clwhite) then
     self.brush.color := clred
  else
     self.brush.color := clwhite;
end;

procedure TLampe.setGroessePosition(x, y: integer);
begin
   self.Height:=46;
   self.Width:=46;
   self.Shape:=stcircle;
   self.Left:=x;
   self.Top:=y;
   self.Cursor:= crhandpoint;
end;

procedure TLampe.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  self.LichtAnAus;
   if links <> nil then
       links.LichtAnAus;
  if rechts <> nil then
       rechts.LichtAnAus;
  if oben <> nil then
       oben.LichtAnAus;
  if unten <> nil then
        unten.LichtAnAus;
end;



{ TForm1 }

{procedure TLampe.LichtAnAus;
begin

end;

procedure TLampe.setGroessePosition(x, y: integer);
begin
   self.Height:=46;
   self.Width:=46;
   self.Shape:=stcircle;
   self.Left:=x;
   self.Top:=y;
   self.Cursor:= crhandpoint;
end;

procedure TLampe.NachbarnReferenzieren (u, l, o, r: TLampe);
begin

end;

procedure TLampe.MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  self.LichtAnAus;
  if links <> nil then
       links.LichtAnAus;
  if rechts <> nil then
       rechts.LichtAnAus;
  if oben <> nil then
       oben.LichtAnAus;
  if unten <> nil then
        unten.LichtAnAus;
end;
            }


procedure TForm1.FormCreate(Sender: TObject);
 var Zeile, Spalte : integer;
begin
    // Damit das Referenzieren leichter geht
    for Zeile := 0 to 6 do
      for Spalte := 0 to 6 do
         begin
         a[Zeile,Spalte] := nil
         end;

    for Zeile := 1 to 5 do
      for Spalte := 1 to 5 do
         begin
         a[Zeile,Spalte] := TLampe.create(self);
         a[Zeile,Spalte].Parent := Form1;
         a[Zeile,Spalte].setGroessePosition (20 + (Zeile-1)*50, 20 + (Spalte-1)*50);
         end;

   for Zeile := 1 to 5 do
      for Spalte := 1 to 5 do
         begin
         // bei 1 und 5 wird auf nil referenziert
         a[Zeile,Spalte].NachbarnReferenzieren(a[Zeile-1, Spalte] , a[Zeile,Spalte-1], a[Zeile+1,Spalte], a[Zeile, Spalte+1]);
         end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i: integer;
begin
  randomize;
  timer1.Enabled:=false;
  for i := 1 to random(10)+1 do
      a[random(5)+1, random(5)+1].MouseDown(mbleft,[ssShift],1,1);

end;



end.
                                                                                      }


var
  Form1: TForm1;
  minenZahl: integer = 20;
  markieren: boolean;

  a : array[0..16, 0..16] of TMineButton;

implementation

{$R *.lfm}

procedure TMineButton.setGroessePosition(x, y: integer);
begin
   self.Height:=25;
   self.Width:=25;
   //self.Shape:=stcircle;
   self.Left:=x;
   self.Top:=y;
   self.Cursor:= crhandpoint;
end;

procedure TMineButton.WertBerechnen; // alle 9 angrenzenden Felder müssen abgefragt werden
begin
  if self.wert <> -1 then;
      begin
        if self.oben <> nil then
          begin
           if self.oben.wert = -1 then
              self.wert:= self.wert+1;
           if self.oben.links <> nil then
               if self.oben.links.wert = -1 then
                   self.wert := self.wert + 1;
           if self.oben.rechts <> nil then
               if self.oben.rechts.wert = -1 then
                   self.wert := self.wert + 1;
          end;

         if self.links <> nil then
            if self.links.wert = -1 then
                self.wert:=self.wert +1;

         if self.rechts <> nil then
            if self.rechts.wert = -1
             then self.wert:=self.wert +1; ;

         if self.unten <> nil then
          begin
           if self.unten.wert = -1 then
              self.wert:= self.wert+1;
           if self.unten.links <> nil then
               if self.unten.links.wert = -1 then
                   self.wert := self.wert + 1;
           if self.unten.rechts <> nil then
               if self.unten.rechts.wert = -1 then
                   self.wert := self.wert + 1;
          end;
      end;
end;


constructor TMineButton.create(AOwner: TComponent);
begin
  inherited create(AOwner);
  self.Font.Style := [fsbold];
  self.Font.Name := 'Tahoma';
  self.AutoSize := false;
  self.Alignment := taCenter;
  self.color := clltgray;
  self.layout := tlcenter;
  //self.height := 16;
  //self.width := 16;
  self.wert := 0;
  self.markiert := false;
end;

procedure TMineButton.NachbarnReferenzieren(u, l, o, r: TMineButton);
begin
    self.links := l;
    self.oben := o;
    self.rechts := r;
    self.unten := u;
end;

procedure TMineButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if button = mbLeft then
  begin
    //if wert > 0 then
      caption := inttostr(wert);
    color := clwhite;
  end;


  if button = mbRight then
  begin
    markiert := true;
    if color <> clgreen then
      color := clgreen
    else
      color := clltgray;
  end;


end;

procedure TForm1.FormCreate(Sender: TObject);
var i, j: integer;
x, y: integer;
Zeile, Spalte: integer;
begin

    // Damit das Referenzieren leichter geht
    for Zeile := 0 to 16 do
      for Spalte := 0 to 16 do
         begin
         a[Zeile,Spalte] := nil
         end;

    for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         begin
         a[Zeile,Spalte] := TMineButton.create(self);
         a[Zeile,Spalte].Parent := Form1;
         a[Zeile,Spalte].setGroessePosition (20 + (Zeile-1)*26, 20 + (Spalte-1)*26);
         end;

    // Fenstergröße
    self.Width:= 26*15 + 20*2;
    self.Height:= 26*15 + 20*2; ;

   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         begin
         // bei 1 und 5 wird auf nil referenziert
         a[Zeile,Spalte].NachbarnReferenzieren(a[Zeile-1, Spalte] , a[Zeile,Spalte-1], a[Zeile+1,Spalte], a[Zeile, Spalte+1]);
         end;

  // Minen legen
  // Minen können zufällig auch doppelt belegt sein (macht hier aber nichts)
  randomize;
  for i:=1 to minenZahl do
  begin
     x := random (14)+1;
     y := random (14)+1;
     a[x,y].wert := -1;
  end;

   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         a[Zeile,Spalte].WertBerechnen;



  // Felder berechnen
  {for i:=1 to 15 do
    for j:=1 to 15 do
    begin


      if a[i,j].wert <> -1 then
      begin
        if (i>0) and (j>0) then
          if button[i-1,j-1].wert = -1 then inc(button[i,j].wert);
        if i>0 then
          if button[i-1,j].wert = -1 then inc(button[i,j].wert);
        if (i>0) and (j<14) then
          if button[i-1,j+1].wert = -1 then inc(button[i,j].wert);
        if j>0 then
          if button[i,j-1].wert = -1 then inc(button[i,j].wert);
        if j<14 then
          if button[i,j+1].wert = -1 then inc(button[i,j].wert);
        if (i<14) and (j>0) then
          if button[i+1,j-1].wert = -1 then inc(button[i,j].wert);
        if i<14 then
          if button[i+1,j].wert = -1 then inc(button[i,j].wert);
        if (i<14) and (j<14) then
          if button[i+1,j+1].wert = -1 then inc(button[i,j].wert);
      end;
    end; }
end;

procedure TForm1.aufdecken(i, j: integer);
begin
  {if button[i,j].wert > 0 then
    button[i,j].Caption := inttostr(button[i,j].wert);
  if button[i,j].wert = -1 then
    button[i,j].Caption := 'X';
  if button[i,j].wert <> -1 then
    button[i,j].Color := clwhite
  else
    button[i,j].Font.Color := clred; }
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i, j: integer;
  verloren: boolean;
begin
 { for i := 0 to 14 do
    for j := 0 to 14 do
      if (button[i,j].color = clwhite) and (button[i,j].wert = 0) then
      begin
        if (i>0) and (j>0) then aufdecken(i-1,j-1);
        if i>0 then aufdecken(i-1,j);
        if (i>0) and (j<14) then aufdecken(i-1,j+1);
        if j>0 then aufdecken(i,j-1);
        if j<14 then aufdecken(i,j+1);
        if (i<14) and (j>0) then aufdecken(i+1,j-1);
        if i<14 then aufdecken(i+1,j);
        if (i<14) and (j<14) then aufdecken(i+1,j+1);    }
     end;

  // Niederlage erkennen
 { verloren := false;
  for i := 0 to 14 do
    for j := 0 to 14 do
      if (button[i,j].color = clwhite) and (button[i,j].wert = -1) then
      begin
        verloren := true;
        timer1.enabled := false;
        button[i,j].color := clred;
      end;

  if verloren then
  begin
    for i := 0 to 14 do
      for j := 0 to 14 do
      begin
        aufdecken(i,j);
      end;
  end;
end;      }

end.

