import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.Timer;
import java.util.*;

/**
TMineButton = class(TLabel)
     public
      wert: integer;
      markiert: boolean;
      links, oben, rechts, unten : TMineButton;
      aufgedeckt : boolean;
      constructor create(AOwner: TComponent);  override;
      procedure NachbarnReferenzieren (o, r, u, l: TMineButton);
      procedure setGroessePosition(x, y: integer);
      procedure WertBerechnen;
      procedure Aufdecken;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;


type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);

  end;



var
  Form1: TForm1;
  MinenZahl: integer = 15;
  markieren: boolean;

  a : array[0..16, 0..16] of TMineButton;

implementation

{$R *.lfm}

procedure TMineButton.setGroessePosition(x, y: integer);
begin
   self.Height:=30;
   self.Width:=30;
   self.Left:=x;
   self.Top:=y;
   self.Cursor:= crhandpoint;
end;

procedure TMineButton.WertBerechnen; // alle 8 angrenzenden Felder mssen abgefragt werden
begin
if self.wert <> -1 then
begin
 if (self.oben <> nil) and (self.oben.wert = -1) then
      self.wert:=self.wert +1;
 if (self.rechts <> nil) and (self.rechts.wert = -1) then
      self.wert:=self.wert +1;
 if (self.unten <> nil) and (self.unten.wert = -1) then
      self.wert:=self.wert +1;
 if (self.links <> nil) and (self.links.wert = -1) then
      self.wert:=self.wert +1;



 if (self.oben <> nil) and (self.oben.links <> nil) and (self.oben.links.wert = -1) then
      self.wert:=self.wert +1;
 if (self.oben <> nil) and (self.oben.rechts <> nil) and (self.oben.rechts.wert = -1) then
      self.wert:=self.wert +1;
 if (self.unten <> nil) and (self.unten.links <> nil) and (self.unten.links.wert = -1) then
      self.wert:=self.wert +1;
 if (self.unten <> nil) and (self.unten.rechts <> nil) and (self.unten.rechts.wert = -1) then
      self.wert:=self.wert +1;
end;

end;

procedure TMineButton.Aufdecken;
begin
  if self.wert = 0 then
  begin
     self.Color:= clwhite;
     self.aufgedeckt:=true;


    if self.oben <> nil then
        if (self.oben.wert = 0) and (self.oben.aufgedeckt=false) then
           self.oben.Aufdecken;

     if self.rechts <> nil then
        if (self.rechts.wert = 0)  and (self.rechts.aufgedeckt=false) then
          self.rechts.Aufdecken;

     if self.unten <> nil then
        if (self.unten.wert = 0)  and (self.unten.aufgedeckt=false) then
          self.unten.Aufdecken;

     if self.links <> nil then
        if (self.links.wert = 0)  and (self.links.aufgedeckt=false) then
          self.links.Aufdecken;

  end;
end;


constructor TMineButton.create(AOwner: TComponent);
begin
  inherited create(AOwner);
  self.Font.Style := [fsbold];
  self.Font.Name := 'Tahoma';
  self.AutoSize := false;
  self.Alignment := taCenter;
  self.color := clltgray;
  self.layout := tlcenter;
  //self.height := 16;
  //self.width := 16;
  self.wert := 0;
  self.markiert := false;
  self.aufgedeckt:= false;
end;

procedure TMineButton.NachbarnReferenzieren(o, r, u, l: TMineButton);
begin
    self.links := l;
    self.oben := o;
    self.rechts := r;
    self.unten := u;
end;

procedure TMineButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if button = mbLeft then
  begin
    if self.wert > 0 then
      begin
      caption := inttostr(wert);
      color := clwhite
      end
    else if wert = -1 then
      begin
      caption := 'X';
      color := clred;
      end
    else if wert = 0 then
      begin
      self.Aufdecken;
      end;
  end;


  if button = mbRight then
  begin
    if color <> clyellow then
      color := clyellow
    else
      color := clltgray;
  end;


end;

procedure TForm1.FormCreate(Sender: TObject);
var i, j: integer;
x, y: integer;
Zeile, Spalte: integer;
begin

    // Damit das Referenzieren leichter geht
    for Zeile := 0 to 16 do
      for Spalte := 0 to 16 do
         begin
         a[Zeile,Spalte] := nil
         end;

    for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         begin
         a[Zeile,Spalte] := TMineButton.create(self);
         a[Zeile,Spalte].Parent := Form1;
         a[Zeile,Spalte].setGroessePosition (20 + (Spalte-1)*31, 20 + (Zeile-1)*31);
                                           // Spalten - AUFPASSEN !!!!!    Zeilen - AUFPASSEN!!!!  Gre +1
         end;

    // Fenstergre
    self.Width:= 31*15 + 20*2;   // (Kstchengre +1 ) * Anzahl der Kstchen +  2* Rand
    self.Height:= 31*15 + 20*2; ;

   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         begin
         // bei 1 und 5 wird auf nil referenziert   -->>  oben, rechts, unten, linke:
         a[Zeile,Spalte].NachbarnReferenzieren(a[Zeile-1, Spalte] , a[Zeile,Spalte+1], a[Zeile+1,Spalte], a[Zeile, Spalte-1]);
         end;

  // Minen legen
  // Minen knnen zufllig auch doppelt belegt sein (macht hier aber nichts)
  randomize;

  //x:= 5; y := 1;
  for i:=1 to minenZahl do
  begin
     x :=  random (15)+1;
     y := random (15)+1;
     a[x,y].wert := -1; // Minen -1
  end;

   for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         a[Zeile,Spalte].WertBerechnen;

  //!!!!!!!!!!!!!!!!!!!
  { for Zeile := 1 to 15 do
      for Spalte := 1 to 15 do
         a[Zeile,Spalte].caption := IntToStr(a[Zeile,Spalte].wert);  }

end;                                                                 
  */

public class Minesweeper extends JFrame {
  // Anfang Attribute
  private JButton jButton1 = new JButton();
  // Ende Attribute
  
  
  
  
  public class Lampe extends JLabel {
    Lampe links, rechts,oben, unten;
    
    Lampe () {
      this.addMouseListener(new MouseAdapter() { 
        public void mousePressed(MouseEvent evt) { 
          LichtAnAus();
          
          if (links != null) {
            links.LichtAnAus();
          }
          if (rechts != null) {
            rechts.LichtAnAus();
          }
          if (oben != null) {
            oben.LichtAnAus();
          }
          if (unten != null) {
            unten.LichtAnAus();
          }
        }
      });  
    }
    
    
    void NachbarnReferenzieren (Lampe u, Lampe l, Lampe o, Lampe r) {
      this.oben = o;
      this.unten = u;
      this.rechts = r;
      this.links = l;
      
    }
    
    
    void LichtAnAus () {
      if (this.getBackground() == Color.WHITE) {
        this.setBackground(Color.RED);
      } // end of if
      else {
        this.setBackground(Color.WHITE);
      } // end of if-else
      
    }
    
    
    
    
    void setGroessePosition(int x, int y) {
      this.setSize(46,46);
      this.setLocation(x,y);
      this.setOpaque(true);
      this.setBackground(Color.WHITE);
      this.setCursor(new Cursor(Cursor.HAND_CURSOR));
      this.setVisible(true);  
    }   
    
    void NachbarnUmschalten() {
      this.LichtAnAus();
      if (this.links != null) {
        links.LichtAnAus();
      }
      if (this.rechts != null) {
        rechts.LichtAnAus();
      }
      if (this.oben != null) {
        oben.LichtAnAus();
      }
      if (this.unten != null) {
        unten.LichtAnAus();
      }
    }
    
    
    
  }  
  
  public Minesweeper(String title) { 
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 432; 
    int frameHeight = 459;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    
    jButton1.setBounds(16, 6, 92, 30);
    jButton1.setText("jButton1");
    jButton1.setMargin(new Insets(2, 2, 2, 2));
    jButton1.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);
    // Ende Komponenten
    
    setVisible(true);
    cp.setBackground(Color.GRAY);
    
    Lampe[][] a = new Lampe[7][7];
    
    
    for (int i=0; i<7;i++) {
      for (int j=0; j<7 ;j++ ) {
        a[i][j] = null;
      }     
    }     
    
    for (int i=1; i<6;i++) {
      for (int j=1; j<6 ;j++ ) {
        a[i][j] = new Lampe();
      } // end of for
    } // end of for
    
    for (int i=1; i<6;i++) {
      for (int j=1; j<6 ;j++ ) {
        cp.add(a[i][j]);
        a[i][j].setGroessePosition (20 + (i-1)*50, 20 + (j-1)*50); 
      }
    }
    
    for (int i=1; i<6;i++) {
      for (int j=1; j<6 ;j++ ) {
        a[i][j].NachbarnReferenzieren(a[i-1][j] , a[i][j-1], a[i+1][j], a[i][j+1]);
      } // end of for 
    } // end of for
    
    
    ActionListener TimerProzedur = new ActionListener() {
      public void actionPerformed (ActionEvent evt) {
        
        Random r = new Random();
        
        for (int i=0; i<3;i++) {            
          a[r.nextInt(5)+1][r.nextInt(5)+1].NachbarnUmschalten();
          
        }
      }
      
    };
    
    
    Timer t = new Timer(500, TimerProzedur);
    t.setRepeats(false);
    t.start(); 
    
    
    
  } // end of public Minesweeper
  
  
  
  
  // Anfang Methoden
  public void jButton1_ActionPerformed(ActionEvent evt) {
    // TODO hier Quelltext einfgen
  } // end of jButton1_ActionPerformed
  
  // Ende Methoden
  
  public static void main(String[] args) {
    new Minesweeper("Minesweeper");
  } // end of main
  
} // end of class LightsOutSchritt1
  